package net.t2code.alias.Spigot.system;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.cmdManagement.AliasCmdExecuter;
import net.t2code.alias.Spigot.cmdManagement.TabEvent;
import net.t2code.alias.Spigot.config.alias.CreateExampleAliasConfig;
import net.t2code.alias.Spigot.config.alias.SelectAlias;
import net.t2code.alias.Spigot.config.config.Config;
import net.t2code.alias.Spigot.config.config.FileSelect;
import net.t2code.alias.Spigot.config.subAlias.CreateExampleSubAliasConfig;
import net.t2code.alias.Spigot.config.subAlias.SelectSubAlias;
import net.t2code.alias.Spigot.confirm.ChatConfirm;
import net.t2code.alias.Spigot.confirm.gui.GuiListener;
import net.t2code.alias.Spigot.enums.Confirm;
import net.t2code.alias.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.register.T2Cregister;
import net.t2code.t2codelib.SPIGOT.api.update.T2CupdateAPI;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CLibConfig;
import org.bukkit.Bukkit;
import org.bukkit.event.HandlerList;

import java.io.File;
import java.util.List;

public class Load {
    private static final Main plugin = Main.getPlugin();

    public static void onLoad(String prefix, List<String> autor, String version, String spigot, String discord, int bstatsID) {
        Long long_ = T2Ctemplate.onLoadHeader(prefix, autor, version, spigot, discord);
        plugin.getCommand("t2code-alias").setExecutor(new AliasCmdExecuter());
        loadReload();
        T2CupdateAPI.onUpdateCheck(plugin, prefix, Util.getGit(), Util.getSpigotID(), Util.getDiscord(),
                (Boolean) Config.updateCheckOnJoin.value, (Boolean) Config.updateCheckSeePreReleaseUpdates.value, (Integer) Config.updateCheckTimeInterval.value);

        T2Ctemplate.onLoadFooter(prefix, long_);
        T2Cregister.listener(new PluginEvents(), plugin);
        Metrics.Bstats(plugin, bstatsID);
    }

    private static ChatConfirm chatListener;
    private static GuiListener guiListener;

    public static void loadReload() {
        HandlerList.unregisterAll(chatListener);
        HandlerList.unregisterAll(guiListener);
        FileSelect.config();
        T2Ctemplate.onLoadSeparateStroke(Util.getPrefix());
        FileSelect.language();
        if (!new File(Main.getPath(), "config.yml").exists()) {
            try {
                CreateExampleAliasConfig.configCreate();
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                CreateExampleSubAliasConfig.configCreate();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        try {
            plugin.saveResource("Alias/X_aliasDeclaration_X.yml", true);
        } catch (Exception e) {
            e.printStackTrace();
        }

        try {
            plugin.saveResource("X_configDeclaration_X.yml", true);
        } catch (Exception e) {
            e.printStackTrace();
        }

        try {
            plugin.saveResource("SubAlias/X_subAliasDeclaration_X.yml", true);
        } catch (Exception e) {
            e.printStackTrace();
        }

        T2Ctemplate.onLoadSeparateStroke(Util.getPrefix());
        SelectAlias.onSelect();
        T2Ctemplate.onLoadSeparateStroke(Util.getPrefix());
        SelectSubAlias.onSelect();
        if ((Boolean) Config.subAliasTab.value) {
            T2Cregister.listener(new TabEvent(), plugin);
        }
        chatListener = new ChatConfirm();
        if (Config.buyConfirmDefault.value == Confirm.CHAT) T2Cregister.listener(chatListener, plugin);
        guiListener = new GuiListener();
        if (Config.buyConfirmDefault.value == Confirm.GUI) T2Cregister.listener(guiListener, plugin);
        if (T2CLibConfig.getBungee()) {
            Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, "t2c:bcmd");
        }
        AliasRegisterPermissions.onPermRegister();
    }

}
